using System;
using System.Web;
using Microsoft.AspNet.SignalR;
using AutomationHub.DAL;
namespace AutomationHub
{
    public class HomeAutomationHub : Hub
    {
        //Server-Side Message that receives the Automation Signal 
        //from the clients
        public void AutomationCommand(string buttonId, string codeKey)
        {

            //Create the Database Service
	    //TODO: Introduce a Business Logic Layer to abstract the Hub
	    //from the implementation details of the SQL Database
	    AutoHubDBService hubDBS = new AutoHubDBService();
            string irCode = hubDBS.GetCodeByKey(codeKey);

            //#####################################
            // IMPORTANT! Make note of the jQuery SignalR CLIENT API CONVENTIONS
            //#####################################
            // Client functions must follow camelCase naming convention
            // This fails! SendCommandToClient
            // But this works. sendCommandToClient
            
            //TODO: Validate buttonId here
            //TODO: SECURITY: Add a third argument to accept a secret key

            //TODO: Send *only* to an identified client!

            //When the client(such as a Python program running on Raspi)
            //receives this command, it will trigger the appropriate 
            //relay to turn on/off the target of automation (such as a remote)
            Clients.All.sendCommandToClient(buttonId, irCode);
        }
    }
}